package AutoAnnotation;

//import com.hp.hpl.jena.graph.query.Query;
import Index.IndexJDialog;
import Ontology.AnnotationObj;
import Ontology.Ontology;
import edu.stanford.smi.protegex.owl.model.OWLModel;
import gontogle.MainFrame;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.analysis.Token;
import org.apache.lucene.index.Term;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.TermQuery;
//import org.apache.lucene.search.BooleanClause;
import org.apache.lucene.search.BooleanClause.Occur;
//import org.apache.lucene.search.Query;

/**
 * AutomaticAnnotator.java
 * Dexetai text apo thn AutomaticAnnotatorResults, to epeksergazetai,
 * briskei to ba8mo omoiothtas tou kemenou me tous kombous twn ontologiwn
 * kai stelnei tis epiloges (klaseis kai score) gia to xrhsth.
 */
public class AutomaticAnnotator {

    public static int K; //To K tou K-NN

    /**Experiment:Grafei sto experimentResults.txt, ta apotelesmata kathgoriopoihshs twn peiramatwn(dhl tou mazikou auto annotation)*/
    static void experimentAutoAnnotator(File directory) {
        try {
            BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("experimentResults.txt")));
            for (File f : directory.listFiles()) {
                BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
                StringBuilder text = new StringBuilder();
                String line;
                while ((line = br.readLine()) != null) {
                    text.append(line);
                    text.append(" ");
                }
                br.close();
                LinkedHashMap<String, Float> results = annotate(text.toString(), f.getAbsolutePath());
                System.out.println("Found " + results.size() + " results for " + f.getName());
                bw.append(f.getName());
                for (Map.Entry<String, Float> e : results.entrySet()) {
                    System.out.println(e.getKey());
                    String n = e.getKey();
                    n = n.substring(0, n.indexOf('_'));
                    bw.append("\t" + n + "," + e.getValue());
                }
                bw.newLine();
            }
            bw.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    //epistrefei ta K simiral Doc ta opoia exun instances kai me normalized pososto similarity
    static PathAndScore[] getSimilarDoc(String text, String searchFile2) {


        PathAndScore[] similarDocs = findSimilarDocs(text); //Pinakas pou periexei ta eggrafa taxinomhmena me to score tous.
       
        ArrayList<PathAndScore> newSimilarDocs = new ArrayList<PathAndScore>();//ta m<=K similar p exun instances

        OWLModel owlModel = (OWLModel) MainFrame.owlModel; //Ftiaxnw antikeimeno owlModel ths trexousas ontologias

        //vriskw ta K pio omoia ta opia exun intances
        int m = 0;
        for (int i = 0; i < similarDocs.length; i++) {
            ArrayList<AnnotationObj> ind = Ontology.getInsancesForDoc(owlModel, similarDocs[i].path);

            if (ind == null || ind.isEmpty()) {
                continue;
            }
            newSimilarDocs.add(similarDocs[i]);
            m++;
            if (m < K) {
                continue;
            }
            else {
                break;
            }
        }

        //kanw normalized ta newSimilar
        float scoreSum = 0;
        for (int i = 0; i < newSimilarDocs.size(); i++) {
            scoreSum += newSimilarDocs.get(i).score;
        }


        PathAndScore[] normSimilarDocs = new PathAndScore[newSimilarDocs.size()];//ta m<=K similar p exun instances me normalized pososta
        for (int i = 0; i < newSimilarDocs.size(); i++) {
            normSimilarDocs[i] = newSimilarDocs.get(i);
            normSimilarDocs[i].score = normSimilarDocs[i].score * (1 / scoreSum);
        }
        return normSimilarDocs;

    }

    static LinkedHashMap<String, Float> classSimilarities(PathAndScore[] normSimilarDocs) {

        LinkedHashMap<String, Float> classesAndSimilaritis = new LinkedHashMap<String, Float>();

        OWLModel owlModel = (OWLModel) MainFrame.owlModel; //Ftiaxnw antikeimeno owlModel ths trexousas ontologias

//for each doc find the classes and the all the percentance
        for (int i = 0; i < normSimilarDocs.length; i++) {
            ArrayList<AnnotationObj> ind = Ontology.getInsancesForDoc(owlModel, normSimilarDocs[i].path);
            LinkedHashMap<String, Float> classesAndPercents = new LinkedHashMap<String, Float>();

            for (int j = 0; j < ind.size(); j++) {
                ArrayList<String> classes = ind.get(j).classes;
                for (int cl = 0; cl < classes.size(); cl++) {
                    if (classesAndPercents.containsKey(classes.get(cl))) {
                        float oldPerc = classesAndPercents.get(classes.get(cl));

                        //float newPerc = oldPerc+ ((((float)ind.get(j).count)/((float)MainFrame.getTsel().getTotalWords()))*((float)100));
                        float newPerc = oldPerc+ ind.get(j).percent;
                        classesAndPercents.put((classes.get(cl)), newPerc);
                    }
                    else {
                          float perc = ind.get(j).percent;
                       //float perc=((((float)ind.get(j).count)/((float)MainFrame.getTsel().getTotalWords()))*((float)100));
                        classesAndPercents.put((classes.get(cl)), perc);
                    }
                }
            }


            for (Entry<String, Float> entry : classesAndPercents.entrySet()) {
                float classSimil = entry.getValue() * normSimilarDocs[i].score;
                if (classesAndSimilaritis.containsKey(entry.getKey())) {
                    float oldSim = classesAndSimilaritis.get(entry.getKey());
                    float newSim = oldSim + classSimil;
                    classesAndSimilaritis.put(entry.getKey(), newSim);
                }
                else {
                    classesAndSimilaritis.put(entry.getKey(), classSimil);
                }
            }
        }

        //normalize similarities
        float sumSimil = 0;
        for (Entry<String, Float> entry : classesAndSimilaritis.entrySet()) {
            sumSimil += entry.getValue();
        }

        for (Entry<String, Float> entry : classesAndSimilaritis.entrySet()) {
            entry.setValue(entry.getValue() * (((float)100) / sumSimil));
        }

        return classesAndSimilaritis;
    }

    /** Dexetai to pros annotation eggrafo kai to keimeno tou. Epistrefei tous epikratesterous
     * kombous-klaseis kai to score tou*/
    static LinkedHashMap<String, Float> annotate(String text, String searchFile2) {
////        // vres ta pio omoia eggrafa me to score tous.
////        PathAndScore[] similarDocs = findSimilarDocs(text); //Pinakas pou periexei ta eggrafa taxinomhmena me to score tous.
////        //System.out.println(Arrays.toString(similarDocs));
////
//////        fixPathName(similarDocs);  //ftiaxe to onoma tous kata thn methodo poy xrhsimopoieitai sto GoNTogle 1.
////
////
////        //apo protege, vres tis kathgories tous
////        //ArrayList<String> similarDocClasses = new ArrayList<String> ();//new OWLNamedClass[K];//ftiaxnw pinaka klasewn toswn osa kai ta K pio omoia eggrafa
////
////        LinkedHashMap<Integer, ArrayList<ClassAndScore>> classAndScores = new LinkedHashMap<Integer, ArrayList<ClassAndScore>>();
////        OWLModel owlModel = (OWLModel) MainFrame.owlModel; //Ftiaxnw antikeimeno owlModel ths trexousas ontologias
////
////        int m = 0;
////        for (int i = 0; i < similarDocs.length; i++) {
////            ArrayList<AnnotationObj> ind = Ontology.getInsancesForDoc(owlModel, similarDocs[i].path);
////
////            if (ind == null || ind.isEmpty()) {
////                //System.out.println("Individual null");
////                continue;
////            }
////
////
////            ArrayList<String> annotClasses = new ArrayList<String>();
////            //for each doc instance get all the annotated classes
////            for (int j = 0; j < ind.size(); j++) {
////                annotClasses.addAll(ind.get(j).classes);
////            }
////            int iter;
////            ArrayList<ClassAndScore> allClassesAndScores = new ArrayList<ClassAndScore>();
////            for (int j = 0; j < annotClasses.size(); j++) {
////                ClassAndScore cs = new ClassAndScore(annotClasses.get(j), similarDocs[i].score);
////                for (iter = 0; iter < allClassesAndScores.size(); iter++) {
////                    if (allClassesAndScores.get(iter).className.compareToIgnoreCase(annotClasses.get(j)) == 0) {
////                        break;
////                    }
////                }
////                if (iter == allClassesAndScores.size()) {
////                    allClassesAndScores.add(cs);
////                }
////            }
////
////            classAndScores.put(m, allClassesAndScores);
////
////            m++;
////            if (m < K) {
////                continue;
////            }
////            else {
////                break;
////            }
////        }
//
//
//        if (MainFrame.classifierFlag == 1) {
//            //       MainFrame.classifierFlag = 0; //Epanaferei to flag sto 0, dhladh sth default me8odo gia classification
//            return WeightedKNN(classAndScores); ////Epistrefei tous epikratesterous kombous k to score tous meta apo weighted KNN
//        }
//        else {
//            return SimpleKNN(classAndScores); //Epistrefei tous epikratesterous kombous k to score tous meta apo KNN
//        }

        return classSimilarities(getSimilarDoc(text, searchFile2));
    }

    /** Ypologizei to ba8mo omoiothtas tou dosmenou eggrafou, me ola ta eggrafa tou
     *  trexontos eurethriou, ta opoia taxinomei kai epistrefei ta onomata kai to score tous*/
    public static PathAndScore[] findSimilarDocs(String queryText) {

        try {
            //Diabazw to trexon index tou Lucene
            String index;
            index=MainFrame.indexDir;
//            if (MainFrame.selectedIndex == null || MainFrame.selectedIndex.isEmpty() || MainFrame.selectedIndex.compareTo(MainFrame.noIndexCreated) == 0) {
//                index = IndexJDialog.validateAndUpdateIndexListFile();
//            }
//            else {
//                index = MainFrame.selectedIndex;
//            }

            //Etoimazomai na ftiaksw to query sto Lucene
            IndexReader reader = IndexReader.open(index);
            Searcher searcher = new IndexSearcher(reader);
            Analyzer analyzer = new StandardAnalyzer();

            //Ftiaxnw tf vector tou query-keimenou (oros,syxnoththa emfanishs tou)
            HashMap<String, Integer> tf = new HashMap<String, Integer>();
            TokenStream tokens = analyzer.tokenStream("contents", new StringReader(queryText));
            while (true) {
                Token t = tokens.next();
                if (t == null) {
                    break;
                }
                String term = t.termText();
                if (tf.containsKey(term)) {
                    tf.put(term, tf.get(term) + 1);
                }
                else {
                    tf.put(term, 1);
                }
            }



//            if(tf.size()>MAX_CLAUSES){
//                throw new RuntimeException("Too many clauses");
//            }

            BooleanQuery.setMaxClauseCount(Math.max(tf.size(), 1024)); //8etw to MaxClauseCount toulaxiston iso me ton default 1024.
            //Dhl gia ari8mo orwn>1024 auksanetai.Den ton 8etw panta iso me ton ekastote ari8mo orwn,
            //giati den kserw an xrhsimopoieitai kai allou sto GoNToggle
            BooleanQuery query = new BooleanQuery(); //A Query that matches documents matching boolean combinations of other queries, e.g. TermQuerys

            for (Entry<String, Integer> term : tf.entrySet()) {
                TermQuery tq = new TermQuery(new Term("contents", term.getKey()));
                tq.setBoost(term.getValue()); //vazoume to "boost" tou orou autou iso me to tf tou
                //query.add(tq,false,false); // Eisagw ton oro sto query. (Ta false,false dhlwnoun "clause is optional")

                query.add(tq, Occur.SHOULD);
            }

            //Trexw to query kai pairnw ta apotelesmata.
            Hits hits = searcher.search(query); //A ranked list of documents, used to hold search results.

            System.out.println(hits.length() + " total matching documents");

            PathAndScore[] result = new PathAndScore[hits.length()]; //Pinakas mege8ous isou me ta apotelesmata
            //Gia kathe apotelesma, ta bazw se enan pinaka gia na ta taxinomhsw meta.
            for (int i = 0; i < hits.length(); i++) {
                float score = hits.score(i);
                String path = hits.doc(i).get("path");
                result[i] = new PathAndScore(path, score);
            }

            //Taxinomw ton pinaka result (modified mergesort)
            //(To lucene ta epistrefei taxinomhmena mallon, alla to kanw gia sigouria)
            Arrays.sort(result, new Comparator<PathAndScore>() {

                public int compare(PathAndScore o1, PathAndScore o2) {
                    float number = o1.score - o2.score;
                    if (number < 0) {
                        return 1; //Bazw + anti gia - giati h sort mou ta taxinomei apo to mikrotero sto megalytero, enw egw 8elw to anti8eto.
                    }
                    else if (number > 0) {
                        return -1; //omoiws
                    }
                    return 0;
                }
            });
            //Epistrefei enan pinaka pou periexei ta apotelesmata tou taxinomhmenou pinaka.
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            return new PathAndScore[0]; //An den yparxoyn apotelesmata epistrefw enan adeio pinaka
        }
    }

    /**Pairnei klaseis kai score gia kathe mia. Oi klaseis pshfizoun kai prokyptoun ta pososta ths pshfoforias**/
    public static LinkedHashMap<String, Float> SimpleKNN(LinkedHashMap<Integer, ArrayList<ClassAndScore>> classNScores) {
//        LinkedHashMap<String, Integer> stats = new LinkedHashMap<String, Integer>();
        LinkedHashMap<String, Float> newStats = new LinkedHashMap<String, Float>();//8a periexei tis klaseis me to score tous %
//        for (int i = 0; i < K; i++) {
//            if (classNScores.get(i) != null) {
//
//                ArrayList<ClassAndScore> classes = classNScores.get(i);
//                for (int j = 0; j < classes.size(); j++) {
//                    String owlCl = classes.get(j).className;
//                    if (!stats.containsKey(owlCl)) {
//                        stats.put(owlCl, 1);
//                    }
//                    else {
//                        stats.put(owlCl, stats.get(owlCl) + 1);
//                    }
//                }
//            }
//        }
//        float sum = 0;
//        for (Entry<String, Integer> entry : stats.entrySet()) {
//            sum += entry.getValue();
//
//        }
//
//
//        for (Entry<String, Integer> entry : stats.entrySet()) {
//            float f = entry.getValue();
//            newStats.put(entry.getKey(), (f / sum) * ((float)100)); //score %
//        }
        return newStats;
    }

    /** KNN, opou h pshfos ka8e klashs isoutai me to phliko tou score ths dia to totalScore**/
    public static LinkedHashMap<String, Float> WeightedKNN(LinkedHashMap<Integer, ArrayList<ClassAndScore>> classNScores) {
//        float totalScore = 0; //A8roisma twn score olwn twn klasewn
        LinkedHashMap<String, Float> stats = new LinkedHashMap<String, Float>();
//
//        for (Entry<Integer, ArrayList<ClassAndScore>> entry : classNScores.entrySet()) {
//            //ArrayList<ClassAndScore> cas = entry.getValue().get(0).score;
//            totalScore = totalScore + entry.getValue().get(0).score;
//        }
//
//
//
//        for (int i = 0; i < K; i++) {
//            if (classNScores.get(i) != null) {
//                ArrayList<ClassAndScore> classes = classNScores.get(i);
//
//                for (int j = 0; j < classes.size(); j++) {
//                    String owlCl = classes.get(j).className;
//                    float ithScore = classes.get(j).score;
//                    //System.out.println(ithScore);
//                    float normalizedScore = (ithScore / totalScore) * ((float)100); // [(score klashs)/(synoliko score)]%
//
//                    if (!stats.containsKey(owlCl)) {
//                        stats.put(owlCl, normalizedScore);
//                    }
//                    else {
//                        stats.put(owlCl, stats.get(owlCl) + normalizedScore);
//                    }
//                }
//            }
//        }
        return stats;
    }

    public static class PathAndScore {

        public String path;
        public float score;

        public PathAndScore(String path, float score) {
            this.path = path;
            this.score = score;
        }

        public String toString() {
            return path + " " + score;
        }
    }

    public static class ClassAndScore {

        public String className;
        public float score;

        public ClassAndScore(String className, float score) {
            this.className = className;
            this.score = score;
        }
    }
//    public static class ClassAndPercent {
//
//        public String className;
//        public float percent;
//
//        public ClassAndScore(String className, float percent) {
//            this.className = className;
//            this.percent = percent;
//        }
//    }
}
