/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package CmdLine;

import Index.FileDocument;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.store.LockObtainFailedException;
import org.apache.pdfbox.searchengine.lucene.LucenePDFDocument;

/**
 *
 * @author Cyan
 */
public class IndexInterface {

    public static final String indexDir = "Index";

    public void indexDocument(String docName) {

        IndexWriter writer = null;
        Directory dir = null;
        Analyzer analyzer = null;
        try {
            dir = FSDirectory.getDirectory(indexDir, false);
            analyzer = new StandardAnalyzer();
            writer = new IndexWriter(dir, analyzer, false);
        } catch (FileNotFoundException ex) {
            //ex.printStackTrace();
            System.out.println("Creating new index...");
            try {
                writer = new IndexWriter(dir, analyzer, true);
            } catch (CorruptIndexException ex1) {
                ex1.printStackTrace();
                //Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex1);
            } catch (LockObtainFailedException ex1) {
                ex1.printStackTrace();
                //Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex1);
            } catch (IOException ex1) {
                ex1.printStackTrace();
                //Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex1);
            }
        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        }

        try {

            File file = new File(docName);

            if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("pdf") == 0) {

                //System.out.println("adding pdf file" + file);
                //System.out.println("WHOLE");
                Document luceneDocument = LucenePDFDocument.getDocument(file);
                writer.addDocument(luceneDocument);

            } else if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("doc") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("odt") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("rtf") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("txt") == 0) {

                //System.out.println("adding doc file" + file);
                //System.out.println("WHOLE");
                writer.addDocument(FileDocument.Document(file));

            }
            writer.optimize();
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        }
        
        //attempt to close writer to the lock file is not left out
        try {
            writer.close();
        } catch (CorruptIndexException ex) {
            Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex);
        }

        //display count of index docs
        IndexReader reader;
        try {
            reader = IndexReader.open(dir);
            //System.out.println("Documents indexed: " + reader.numDocs());
            reader.close();
        } catch (CorruptIndexException ex) {
            Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(IndexInterface.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
}
