package Index;

/*
 * IndexJDialog.java
 */
import gontogle.MainFrame;
import Index.FileDocument;
import java.awt.Cursor;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileNotFoundException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import java.io.FileReader;
import java.io.FileWriter;
//import org.apache.lucene.handlingtypes.framework.FileHandlerException;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.lang.String;
import java.util.ArrayList;
import java.util.Properties;
import java.util.Date;
import java.util.Enumeration;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;
import javax.swing.JRadioButton;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.store.LockObtainFailedException;
import org.apache.pdfbox.searchengine.lucene.LucenePDFDocument;
//import org.apache.lucene.handlingtypes.framework.FileIndexer;

public class IndexJDialog extends JDialog {

    public static File indexIndex = null; //Apo8hkeuetai to onoma tou fakelou pou 8a periexei to pros dhmiourgia eurethrio.
    public static File indexData = null; ////Apo8hkeuetai to onoma tou fakelou pou 8a periexei ta pros deiktodothsh arxeia.
    public static final String indexListFileName = "indexList.txt";
    private static final String NL = System.getProperties().getProperty("line.separator");
    private JFrame mainFrame;
    private JRadioButton previusSelected;

    /** Creates new form IndexJDialog */
    public IndexJDialog(JFrame parent, boolean modal) {
        super(parent, true);
        mainFrame = parent;
        this.setLocationRelativeTo(parent);
        this.setTitle("Indexing");
        initComponents();
        RadiobuttonGroup.add(selectRadioButton);
        RadiobuttonGroup.add(createRadioButton);
        FileReader text;
        File f;
        f = new File(indexListFileName);
        if (!f.exists()) {
            try {
                f.createNewFile();
            } catch (IOException ex) {
                Logger.getLogger(IndexJDialog.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        String memory = "";
        memory = validateAndUpdateIndexListFile();
        if (MainFrame.selectedIndex == null || MainFrame.selectedIndex.compareTo(MainFrame.noIndexCreated) == 0) {
            memory = validateAndUpdateIndexListFile();
        } else {
            memory = MainFrame.selectedIndex;
        }
        if (memory.isEmpty()) {
            createRadioButton.setSelected(true);
            selectRadioButton.setSelected(false);
            previusSelected = createRadioButton;
        } else {
            previusSelected = selectRadioButton;
        }
        indexFileTextField.setText(memory);

        if (RadiobuttonGroup.isSelected((ButtonModel) createRadioButton.getModel())) {
            jLabel1.setVisible(true);
        } else {
            jLabel1.setVisible(false);
        }

    }

    /** Xrhsimopoieitai apo to AutoAnnotatorResults gia na kanei index ena eggrafo,
     * pros8etontas to sto trexon eurethrio. Den emfanizei para8yro.*/
    public IndexJDialog(String searchFile, boolean modal) {
        FileReader text;
        File f;
        f = new File(IndexJDialog.indexListFileName);
        if (!f.exists()) {
            try {
                f.createNewFile();
            } catch (IOException ex) {
                Logger.getLogger(IndexJDialog.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        try {
            String memory = "";
            if (MainFrame.selectedIndex == null || MainFrame.selectedIndex.compareTo(MainFrame.noIndexCreated) == 0) {
                memory = validateAndUpdateIndexListFile();
            } else {
                memory = MainFrame.selectedIndex;
            }

//            System.out.println("ekane print ston index....." + memory);

//            Properties props = new Properties();
//            props.load(new FileInputStream("handler.properties"));

            Directory dir = FSDirectory.getDirectory(memory, false);

            Analyzer analyzer = new StandardAnalyzer();
            IndexWriter writer = new IndexWriter(dir, analyzer, false);
            ////giann
//             FileIndexer indexer = new FileIndexer(props);
//            try {
//                indexer.index(writer, new File(searchFile));
//            } catch (FileHandlerException ex) {
//                Logger.getLogger(IndexJDialog.class.getName()).log(Level.SEVERE, null, ex);
//            }
            ////////////////

            //dika mu
            File docDir = new File(searchFile);
            indexDocs(writer, docDir);

            writer.optimize();
            writer.close();

            IndexReader reader = IndexReader.open(dir);
            System.out.println("Documents indexed: " + reader.numDocs());
            reader.close();




        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        }

    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        RadiobuttonGroup = new javax.swing.ButtonGroup();
        indexFilePanel = new javax.swing.JPanel();
        createRadioButton = new javax.swing.JRadioButton();
        selectRadioButton = new javax.swing.JRadioButton();
        indexFileTextField = new javax.swing.JTextField();
        indexSearchButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        dataFilePanel = new javax.swing.JPanel();
        dataFileTextField = new javax.swing.JTextField();
        dataSearchButton = new javax.swing.JButton();
        indexCancelButton = new javax.swing.JButton();
        indexOkButton = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);

        indexFilePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Create or Select Index Folder"));

        RadiobuttonGroup.add(createRadioButton);
        createRadioButton.setText("Create a new Index ");
        createRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        createRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        createRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createRadioButtonActionPerformed(evt);
            }
        });

        RadiobuttonGroup.add(selectRadioButton);
        selectRadioButton.setSelected(true);
        selectRadioButton.setText("Select an already existing Index to add new elements");
        selectRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        selectRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        selectRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectRadioButtonActionPerformed(evt);
            }
        });

        indexFileTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                indexFileTextFieldActionPerformed(evt);
            }
        });

        indexSearchButton.setText("Search");
        indexSearchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                IndexFileSearchPerformed(evt);
            }
        });

        jLabel1.setText("Select folder to save the new Index");

        org.jdesktop.layout.GroupLayout indexFilePanelLayout = new org.jdesktop.layout.GroupLayout(indexFilePanel);
        indexFilePanel.setLayout(indexFilePanelLayout);
        indexFilePanelLayout.setHorizontalGroup(
            indexFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(indexFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(indexFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(indexFilePanelLayout.createSequentialGroup()
                        .add(indexFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(createRadioButton)
                            .add(selectRadioButton))
                        .add(238, 238, 238))
                    .add(indexFilePanelLayout.createSequentialGroup()
                        .add(indexFileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 422, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                        .add(indexSearchButton)
                        .addContainerGap())
                    .add(indexFilePanelLayout.createSequentialGroup()
                        .add(jLabel1)
                        .addContainerGap())))
        );
        indexFilePanelLayout.setVerticalGroup(
            indexFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(indexFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(createRadioButton)
                .add(17, 17, 17)
                .add(selectRadioButton)
                .add(18, 18, 18)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(indexFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(indexFileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(indexSearchButton))
                .addContainerGap())
        );

        dataFilePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Select Data Folder to be Indexed"));

        dataSearchButton.setText("Search");
        dataSearchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DataFileSearchPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout dataFilePanelLayout = new org.jdesktop.layout.GroupLayout(dataFilePanel);
        dataFilePanel.setLayout(dataFilePanelLayout);
        dataFilePanelLayout.setHorizontalGroup(
            dataFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(dataFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(dataFileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 422, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                .add(dataSearchButton)
                .addContainerGap())
        );
        dataFilePanelLayout.setVerticalGroup(
            dataFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(dataFilePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(dataFilePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(dataFileTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(dataSearchButton))
                .addContainerGap(71, Short.MAX_VALUE))
        );

        indexCancelButton.setText("Close");
        indexCancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitItemActionPerformed(evt);
            }
        });

        indexOkButton.setText("Index");
        indexOkButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                IndexActionPerformed(evt);
            }
        });
        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap(405, Short.MAX_VALUE)
                .add(indexOkButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(indexCancelButton)
                .addContainerGap())
            .add(indexFilePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(dataFilePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(indexFilePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(dataFilePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(indexCancelButton)
                    .add(indexOkButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void IndexActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_IndexActionPerformed
        try {


            //cursor
            this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            mainFrame.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            //            Properties props = new Properties();
//            props.load(new FileInputStream("handler.properties"));

            File dir = null;
            if (createRadioButton.isSelected()) {
                //dir = FSDirectory.getDirectory(indexFileTextField.getText(), true);\
                dir = new File(indexFileTextField.getText());
                dir.mkdir();
                insertToIndexListFile(indexFileTextField.getText());

            } else if (selectRadioButton.isSelected()) {
                //dir = FSDirectory.getDirectory(indexFileTextField.getText(), false);
                dir = new File(indexFileTextField.getText());

            }


            Analyzer analyzer = new StandardAnalyzer();
            IndexWriter writer = null;
            if (createRadioButton.isSelected()) {
                writer = new IndexWriter(dir, analyzer, true);
            } else if (selectRadioButton.isSelected()) {
                writer = new IndexWriter(dir, analyzer, false);
            }

            ////giann
//             FileIndexer indexer = new FileIndexer(props);
//            try {
//                indexer.index(writer, new File(searchFile));
//            } catch (FileHandlerException ex) {
//                Logger.getLogger(IndexJDialog.class.getName()).log(Level.SEVERE, null, ex);
//            }
////
//IndexReader.o
            IndexReader reader = IndexReader.open(dir);
            int initNumOfDoc = reader.numDocs();
            File docDir = new File(dataFileTextField.getText());
            indexDocs(writer, docDir);

            writer.optimize();
            writer.close();
            reader.close();
            reader = IndexReader.open(dir);
            JOptionPane.showMessageDialog(this, reader.numDocs() - initNumOfDoc + " Documents Indexed", "Index", JOptionPane.INFORMATION_MESSAGE);
            reader.close();

        } catch (FileNotFoundException ex) {
            ex.printStackTrace();

        } catch (IOException ex) {
            ex.printStackTrace();
        }
        ((MainFrame) mainFrame).initIndexMenu();

        //cursor
        mainFrame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }//GEN-LAST:event_IndexActionPerformed

    static void indexDocs(IndexWriter writer, File file) throws IOException {
        // do not try to index files that cannot be read
        if (file.canRead()) {
            if (file.isDirectory()) {
                System.out.println("found directory" + file);
                String[] tmpfiles = file.list();

                ArrayList<String> files = new ArrayList<String>();
                for (int i = 0; i < tmpfiles.length; i++) {

//                    if (tmpfiles[i].substring(tmpfiles[i].lastIndexOf(".") + 1, tmpfiles[i].length()).compareToIgnoreCase("pdf") == 0 ||
//                            tmpfiles[i].substring(tmpfiles[i].lastIndexOf(".") + 1, tmpfiles[i].length()).compareToIgnoreCase("doc") == 0 ||
//                            tmpfiles[i].substring(tmpfiles[i].lastIndexOf(".") + 1, tmpfiles[i].length()).compareToIgnoreCase("odt") == 0 ||
//                            tmpfiles[i].substring(tmpfiles[i].lastIndexOf(".") + 1, tmpfiles[i].length()).compareToIgnoreCase("rtf") == 0 ||
//                            tmpfiles[i].substring(tmpfiles[i].lastIndexOf(".") + 1, tmpfiles[i].length()).compareToIgnoreCase("txt") == 0) {

                    files.add(tmpfiles[i]);
//                    }

                }
//                "Doc", "txt", "odt", "pdf", "rtf"
                // an IO error could occur
                if (files != null) {
                    for (int i = 0; i < files.size(); i++) {

                        indexDocs(writer, new File(file, files.get(i)));
                    }
                }
            } else {

                try {

                    if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("pdf") == 0) {
                        Document luceneDocument = LucenePDFDocument.getDocument(file);
                        System.out.println("adding pdf file" + file);
                        writer.addDocument(luceneDocument);
                    } else if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("doc") == 0
                            || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("odt") == 0
                            || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("rtf") == 0
                            || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("txt") == 0) {
                        System.out.println("adding doc file" + file);

                        writer.addDocument(FileDocument.Document(file));
                    }
                } // at least on windows, some temporary files raise this exception with an "access denied" message
                // checking if the file can be read doesn't help
                catch (FileNotFoundException fnfe) {
                    System.err.println("Error: " + fnfe.getMessage());
                }
            }
        }
    }

    private void ExitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitItemActionPerformed
        this.setVisible(false);
        ((MainFrame) mainFrame).initIndexMenu();

    }//GEN-LAST:event_ExitItemActionPerformed

    private void DataFileSearchPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DataFileSearchPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.setMultiSelectionEnabled(false);
        chooser.setDialogTitle("Select Data Folder to be Indexed");
        chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        // System.out.println(chooser.getCurrentDirectory().getAbsolutePath());
        chooser.setCurrentDirectory(new File("C:\\"));
        //System.out.println(chooser.getCurrentDirectory().getAbsolutePath());
        int option = chooser.showOpenDialog(this);
        if (option == JFileChooser.APPROVE_OPTION) {
            indexData = chooser.getSelectedFile();
        }
        if (indexData != null) {
            dataFileTextField.setText(indexData.getAbsolutePath());
        }
    }//GEN-LAST:event_DataFileSearchPerformed

    private void IndexFileSearchPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_IndexFileSearchPerformed

        JFileChooser chooser = new JFileChooser();
        chooser.setMultiSelectionEnabled(false);
        chooser.setCurrentDirectory(new File("C:\\"));
        int option;
        if (createRadioButton.isSelected()) {
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            chooser.setDialogTitle("Create a New Index");
            option = chooser.showSaveDialog(this);

            if (chooser != null && !chooser.getSelectedFile().isDirectory()) {
                JOptionPane.showMessageDialog(null, "", "", JOptionPane.ERROR_MESSAGE);
            }
        } else {
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            chooser.setDialogTitle("Open Index");
            option = chooser.showOpenDialog(this);
        }
        if (option == JFileChooser.APPROVE_OPTION) {
            indexIndex = chooser.getSelectedFile();
        }
        if (indexIndex != null) {
            indexFileTextField.setText(indexIndex.getAbsolutePath());
        }

    }//GEN-LAST:event_IndexFileSearchPerformed

    private void insertToIndexListFile(String indexPath) {
        try {
            // Create file
            FileWriter fstream = new FileWriter(indexListFileName, true);
            FileInputStream fINstream = new FileInputStream(indexListFileName);

            DataInputStream in = new DataInputStream(fINstream);

            BufferedWriter out = new BufferedWriter(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));

            //check if already exist
            String directory;
            while ((directory = br.readLine()) != null) {
                if (indexPath.compareToIgnoreCase(directory) == 0) {
                    return;
                }
            }
            out.newLine();
            out.write(indexPath);

            //Close the output stream
            out.close();
        } catch (Exception e) {//Catch exception if any
            System.err.println("Error: " + e.getMessage());
        }

    }

    //chcek for the path existance and also return the final path
    public static String validateAndUpdateIndexListFile() {
        String finalPath = "";
        ArrayList<String> pathList = new ArrayList<String>();
        try {
            FileInputStream fstream = new FileInputStream(indexListFileName);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String directory;
            while ((directory = br.readLine()) != null) {
                File file = new File(directory);
                if (file.exists()) {
                    pathList.add(directory);
                }
            }
            in.close();
        } catch (Exception e) {
            System.err.println("Error: " + e.getMessage());
        }
        try {
            // Create file
            FileWriter fstream = new FileWriter(indexListFileName, false);
            BufferedWriter out = new BufferedWriter(fstream);
            for (int i = 0; i < pathList.size(); i++) {
                finalPath = pathList.get(i);
                out.newLine();
                out.write(finalPath);
            }
            //Close the output stream
            out.close();
        } catch (Exception e) {//Catch exception if any
            System.err.println("Error: " + e.getMessage());
        }
        return finalPath;
    }

    //    //chcek for the path existance and also return all paths.. same as previus function
    public static ArrayList<String> returnAndValidateIndexList() {
        ArrayList<String> finalPath = new ArrayList<String>();
        ArrayList<String> pathList = new ArrayList<String>();
        try {
            FileInputStream fstream = new FileInputStream(indexListFileName);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String directory;
            while ((directory = br.readLine()) != null) {
                File file = new File(directory);
                if (file.exists()) {
                    pathList.add(directory);
                }
            }
            in.close();
        } catch (Exception e) {
            System.err.println("Error: " + e.getMessage());
        }
        try {
            // Create file
            FileWriter fstream = new FileWriter(indexListFileName, false);
            BufferedWriter out = new BufferedWriter(fstream);
            for (int i = 0; i < pathList.size(); i++) {
                finalPath.add(pathList.get(i));
                out.newLine();
                out.write(pathList.get(i));
            }
            //Close the output stream
            out.close();
        } catch (Exception e) {//Catch exception if any
            System.err.println("Error: " + e.getMessage());
        }
        return finalPath;
    }

    private void selectRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectRadioButtonActionPerformed
        // TODO add your handling code here:
        //if(RadiobuttonGroup.isSelected( (ButtonModel) createRadioButton.getModel())){
//System.out.println("select" +getSelection(RadiobuttonGroup).getText());
// System.out.println("kai to kubi"+createRadioButton.getText());
        jLabel1.setVisible(false);
        //if(getSelection(RadiobuttonGroup).getText().compareToIgnoreCase(createRadioButton.getText())!=0){
        if (getSelection(RadiobuttonGroup) != previusSelected) {

            System.out.println("aaaaaaaaa");
            indexFileTextField.setText("");
            previusSelected = getSelection(RadiobuttonGroup);
        }
        // createRadioButton.setSelected(false);
    }//GEN-LAST:event_selectRadioButtonActionPerformed

    private void createRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createRadioButtonActionPerformed
        // TODO add your handling code here:

        jLabel1.setVisible(true);
        if (getSelection(RadiobuttonGroup) != previusSelected) {

            System.out.println("aaaaaaaaa");
            indexFileTextField.setText("");
            previusSelected = getSelection(RadiobuttonGroup);
        }

        // selectRadioButton.setSelected(false);
    }//GEN-LAST:event_createRadioButtonActionPerformed

    private void indexFileTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_indexFileTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_indexFileTextFieldActionPerformed

    // This method returns the selected radio button in a button group
    public static JRadioButton getSelection(ButtonGroup group) {
        for (Enumeration e = group.getElements(); e.hasMoreElements();) {
            JRadioButton b = (JRadioButton) e.nextElement();
            if (b.getModel() == group.getSelection()) {
                return b;
            }
        }
        return null;
    }

    public static void buildIndex() {
        File dir = null;
        dir = new File(MainFrame.indexDir);

        if (dir.isDirectory()) { //index exist
            //nothhing
            System.out.println("yparxi o index");
        } else {//build index
            try {
                System.out.println("den yparxi o index");
                //build index
                dir.mkdir();
                Analyzer analyzer = new StandardAnalyzer();
                IndexWriter writer = null;
                writer = new IndexWriter(dir, analyzer, true);
                writer.optimize();
                writer.close();
            } catch (CorruptIndexException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            } catch (LockObtainFailedException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    static public void indexAnnotatedText() {

        System.out.println("Kalestike h index....");

        
        // do not try to index files that cannot be read
        if (MainFrame.textForIndexing.isEmpty() && MainFrame.wholeDocAnnotFlag == false) {
            System.out.println("NOThing to intex");
            return;
        }
        try {
            Directory dir = FSDirectory.getDirectory(MainFrame.indexDir, false);

            Analyzer analyzer = new StandardAnalyzer();
            IndexWriter writer = new IndexWriter(dir, analyzer, false);

            File file = new File(MainFrame.docjInternalFrame.getTitle());

            if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("pdf") == 0) {

                System.out.println("adding pdf file" + file);
                if (MainFrame.wholeDocAnnotFlag == true) {
                    System.out.println("WHOLE");
                    Document luceneDocument = LucenePDFDocument.getDocument(file);
                    writer.addDocument(luceneDocument);
                } else {
                    System.out.println("text.."+MainFrame.textForIndexing);
                    writer.addDocument(FileDocument.Document(file, MainFrame.textForIndexing));
                }
            } else if (file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("doc") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("odt") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("rtf") == 0
                    || file.getName().substring(file.getName().lastIndexOf(".") + 1, file.getName().length()).compareToIgnoreCase("txt") == 0) {

                System.out.println("adding doc file" + file);
                if (MainFrame.wholeDocAnnotFlag == true) {
                    System.out.println("WHOLE");
                    writer.addDocument(FileDocument.Document(file));
                } else {
                      System.out.println("text.."+MainFrame.textForIndexing);
                    writer.addDocument(FileDocument.Document(file, MainFrame.textForIndexing));
                }
            }
            writer.optimize();
            writer.close();

            IndexReader reader = IndexReader.open(dir);
            System.out.println("Documents indexed: " + reader.numDocs());
            reader.close();

        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        }

        MainFrame.textForIndexing = "";
        MainFrame.wholeDocAnnotFlag = false;
    } // at least on windows, some temporary files raise this exception with an "access denied" message
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup RadiobuttonGroup;
    private javax.swing.JRadioButton createRadioButton;
    private javax.swing.JPanel dataFilePanel;
    private javax.swing.JTextField dataFileTextField;
    private javax.swing.JButton dataSearchButton;
    private javax.swing.JButton indexCancelButton;
    private javax.swing.JPanel indexFilePanel;
    private javax.swing.JTextField indexFileTextField;
    private javax.swing.JButton indexOkButton;
    private javax.swing.JButton indexSearchButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JRadioButton selectRadioButton;
    // End of variables declaration//GEN-END:variables
}
