/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Ontology;

import gontogle.MainFrame;
import java.util.ArrayList;
import java.util.Collections;

/**
 *
 * @author Nikos
 */
public class AnnotationObj {

    public long pos;
    public long count;
    public String docURL;    //xriazete?
    public ArrayList<String> classes;
    public String ClassesStr;
    public String annotatedText; //initalized after the doc parsing and annotation ....//for pdf initilized from the begining
    public String instanceName;
    public Integer color;
    public float percent;   //to pososto tu kimenu pu exi ginei annotation
    public long line;   //not used for pdf
    public long page;   //only for pdf
    public static Integer colors[] = {new Integer(0xFFF40E),
        new Integer(0x6258F2),
        new Integer(0x26F287),
        new Integer(0xFF3636),
        new Integer(0x58F2E1),
        new Integer(0xCBF258),
        new Integer(0xA95EFF),
        new Integer(0xFF9B0E),
        new Integer(0x58A9F2),
        new Integer(0xFF5EFF)
    };

    public AnnotationObj() {
        // annotationsNumber=0;
        classes = new ArrayList<String>();
        pos = -1;
        count = -1;
        docURL = null;
        annotatedText = null;
        instanceName = null;
        color = null;
        percent = 0;
        line = -1;
        page = -1;
    }

    public static ArrayList<AnnotationObj> sortAnnotations(ArrayList<AnnotationObj> annot, boolean docMode) {

//        if (annot.size() == 0) {
//            ArrayList<AnnotationObj> sortedAnnot = new ArrayList<AnnotationObj>();
//            return sortedAnnot;
//        }
        if (annot.size() <= 1) {
            return annot;
        }

        if (docMode) {
            return sortAnnotationsByPos(annot);
        }
        else {
            ArrayList<AnnotationObj> sortedAnnot = new ArrayList<AnnotationObj>();

            ArrayList<AnnotationObj> sortedByPage;
            sortedByPage = sortAnnotationsByPage(annot);

            ArrayList<AnnotationObj> tmp = new ArrayList<AnnotationObj>();

            long prevPage = -1;
            for (int i = 0; i < sortedByPage.size(); i++) {

                if ((prevPage != -1 && prevPage != sortedByPage.get(i).page)) {
                    ArrayList<AnnotationObj> tmp2 = sortAnnotationsByPos(tmp);
                    for (int j =0;j<tmp2.size()  ;j++) {
                        sortedAnnot.add(tmp2.get(j));
                    }
//                           sortedAnnot.addAll();
                    tmp.clear();
                }
                tmp.add(sortedByPage.get(i));
                prevPage = sortedByPage.get(i).page;

                if (i == sortedByPage.size() - 1) {
                    ArrayList<AnnotationObj> tmp2 = sortAnnotationsByPos(tmp);
                    for (int j =0;j<tmp2.size()  ;j++) {
                        sortedAnnot.add(tmp2.get(j));
                    }
//                                    sortedAnnot.addAll(sortAnnotationsByPos(tmp));

                }
            }

            ArrayList<AnnotationObj> tmpsortedAnnot = new ArrayList<AnnotationObj>();
            for (int j = sortedAnnot.size() - 1; j >= 0; j--) {
                tmpsortedAnnot.add(sortedAnnot.get(j));
            }
            return tmpsortedAnnot;
        }
    }

    private static ArrayList<AnnotationObj> sortAnnotationsByPage(ArrayList<AnnotationObj> annot) {
        if (annot.size() <= 1) {
            return annot;
        }
        ArrayList<AnnotationObj> sortedAnnot = new ArrayList<AnnotationObj>();
        ArrayList<Long> page = new ArrayList<Long>();

        for (int i = 0; i < annot.size(); i++) {
            page.add(annot.get(i).page);
            //    System.out.println("before sort " + pos);

        }
        Collections.sort(page);

        for (int i = page.size() - 1; i >= 0; i--) {
            for (int j = 0; j < annot.size(); j++) {
                if (annot.get(j).page == page.get(i)) {
                    sortedAnnot.add(annot.get(j));
                    annot.remove(j);
                }
            }

        }
        return sortedAnnot;

    }

    private static ArrayList<AnnotationObj> sortAnnotationsByPos(ArrayList<AnnotationObj> annot) {
        ArrayList<AnnotationObj> sortedAnnot = new ArrayList<AnnotationObj>();
//        if (annot.size() == 0) {
//            return sortedAnnot;
//        }
        if (annot.size() <= 1) {
            return annot;
        }
        ArrayList<Long> pos = new ArrayList<Long>();

        for (int i = 0; i < annot.size(); i++) {
            pos.add(annot.get(i).pos);
            //    System.out.println("before sort " + pos);

        }
        Collections.sort(pos);
        //    System.out.println("after sort " + pos);
        for (int i = pos.size() - 1; i >= 0; i--) {
            for (int j = 0; j < annot.size(); j++) {
                if (annot.get(j).pos == pos.get(i)) {
                    sortedAnnot.add(annot.get(j));
                    annot.remove(j);
                }
            }

        }
        if (sortedAnnot.get(sortedAnnot.size() - 1).pos == -1) {
            AnnotationObj tmp = sortedAnnot.get(sortedAnnot.size() - 1);
            sortedAnnot.remove(sortedAnnot.size() - 1);
            sortedAnnot.add(0, tmp);
        }

        return sortedAnnot;
    }

    public static Integer chooseColor(ArrayList<AnnotationObj> annotations, long pos, long len) {
        Integer color = null;
        if (annotations.size() < colors.length) {
            return AnnotationObj.colors[annotations.size()];
        }
        else {

            ArrayList<AnnotationObj> tmpAnnot = new ArrayList<AnnotationObj>();
            tmpAnnot.addAll(annotations);
            ArrayList<AnnotationObj> sortAnnot = sortAnnotations(tmpAnnot, MainFrame.ooMode);
            Integer prevColor = null;
            Integer nextColor = null;

//find prev color
            for (int i = 0; i < sortAnnot.size(); i++) {
                if (sortAnnot.get(i).pos > pos) {
                    if (i > 0) {
                        prevColor = sortAnnot.get(i - 1).color;
                    }
                    else {
                        prevColor = null;
                    }
                    break;
                }
            }

//find next color
            for (int i = 0; i < sortAnnot.size(); i++) {
                if (sortAnnot.get(i).pos + sortAnnot.get(i).count > pos + len) {
                    if (i < sortAnnot.size() - 1 && sortAnnot.get(i + 1).pos + sortAnnot.get(i + 1).count < sortAnnot.get(i).pos + sortAnnot.get(i).count) {
                    }
                    else {
                        nextColor = sortAnnot.get(i).color;
                        break;
                    }
                }
            }
//            System.out.println(nextColor);
//            System.out.println(prevColor);

            for (int i = 0; i < colors.length; i++) {
                if (colors[i] != nextColor && colors[i] != prevColor) {
                    color = colors[i];
                    break;
                }
            }
            return color;
        }
    }
}
