/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Ontology;

import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.server.RemoteClientProject;

import edu.stanford.smi.protege.server.RemoteProjectManager;
import edu.stanford.smi.protege.server.RemoteServer;
import edu.stanford.smi.protege.server.RemoteServerProject;
import edu.stanford.smi.protege.server.RemoteSession;
import edu.stanford.smi.protege.server.Server;
//import edu.stanford.smi.protege.server.Server*;

import edu.stanford.smi.protege.util.SystemUtilities;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Hashtable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Nikos
 */
public class ProtegeServer {

    private RemoteServer server;
    private RemoteSession session;
    private Hashtable openedProjects ;

    public ProtegeServer() {
        session = null;
        server = null;
        openedProjects=new Hashtable();
    }
//RemoteProjectManager rpm = RemoteProjectManager.getInstance();
//Project p = rpmgetProject("localhost", "Timothy Redmond", "troglodyte", "Newspaper", true);
//KnowledgeBase kb = p.getKnowledgeBase();


    public RemoteSession connect(String serverIP, String user, String pass) {
        //  RemoteSession session=null;
        try {
            //  RemoteServer
            server = (RemoteServer) Naming.lookup("//" + serverIP + "/" + Server.getBoundName());
            if (server != null) {
                session = server.openSession(user,
                        SystemUtilities.getMachineIpAddress(),
                        pass);
            }
        } catch (Exception e) {
            //Log.getLogger().severe(Log.toString(e));
            //e.printStackTrace();
        }
        return session;

    }

    public Collection<String> getAvailableProjectNames() {
        Collection<String> projNames = null;
        try {
            if (server != null && session != null) {
                projNames = server.getAvailableProjectNames(session);
            }
        } catch (RemoteException ex) {
            Logger.getLogger(ProtegeServer.class.getName()).log(Level.SEVERE, null, ex);
        }
        return projNames;

    }

    public Project openProject(String projName) {

        Project p = null;

//         RemoteProjectManager rpm = RemoteProjectManager.getInstance();
////
// p = rpm.getProject(serverIP, user, pass, projName, true);
////
////KnowledgeBase kb = p.getKnowledgeBase();
////

//        try {
//            RemoteServer server = (RemoteServer) Naming.lookup("//"+serverIP+"/" + Server.getBoundName());
//            if (server != null) {
//                RemoteSession session = server.openSession(user,
//                        SystemUtilities.getMachineIpAddress(),
//                        pass);
        if (session != null) {
            RemoteServerProject serverProject = null;
            try {
                serverProject = server.openProject(projName, session);
//                server.notifyProject(projName, projName, session);

            } catch (RemoteException ex) {
                Logger.getLogger(ProtegeServer.class.getName()).log(Level.SEVERE, null, ex);
            }
            if (serverProject != null) {
                try {
                    p = RemoteClientProject.createProject(server, serverProject, session, true);
                } catch (RemoteException ex) {
                    Logger.getLogger(ProtegeServer.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }

if(p!=null){
    if(!openedProjects.containsKey(projName)){
    openedProjects.put(projName, p);}
}
        return p;


    }

    public void disconect() {
        if (server != null) {
            try {
                server.closeSession(session);
            } catch (RemoteException ex) {
                Logger.getLogger(ProtegeServer.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

//    public void closeProject(String projectName) {
//
//                try {
//                    server.setProjectStatus(projectName,edu.stanford.smi.protege.server.ServerProject.ProjectStatus.SHUTTING_DOWN, session);
//            //   if(p!=null){
//          //  server. shutdownProject(session, projectName, (float) 0.0);
//            // p.dispose();
//            // }
//        } catch (RemoteException ex) {
//            Logger.getLogger(ProtegeServer.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }

    /**
     * @return the server
     */
    public RemoteServer getServer() {
        return server;
    }

    /**
     * @return the session
     */
    public RemoteSession getSession() {
        return session;
    }

    /**
     * @return the openedProjects
     */
    public Hashtable getOpenedProjects() {
        return openedProjects;
    }
//
//private static class ListPanel extends JPanel implements Disposable {
//        private OWLNamedClass destinationClass;
//        private JList list;
//        private DefaultListModel listModel;
//
//        private ModelListener modelListener = new ModelAdapter() {
//            public void individualCreated(RDFResource resource) {
//                if (resource.hasRDFType(destinationClass, true)) {
//                    handleDestinationAdded(resource);
//                }
//            }
//        };
//
//        private OWLModel owlModel;
//
//        ListPanel(OWLNamedClass activityClass) {
//            this.destinationClass = activityClass;
//            this.owlModel = activityClass.getOWLModel();
//
//            owlModel.addModelListener(modelListener);
//
//            listModel = new DefaultListModel();
//            for (Iterator it = activityClass.getInstances(true).iterator(); it.hasNext();) {
//                OWLIndividual individual = (OWLIndividual) it.next();
//                listModel.addElement(individual);
//            }
//            list = new JList(listModel);
//
//            // Make sure list entries show up nicely with icons
//            list.setCellRenderer(new ResourceRenderer());
//
//            // Wrap the list together with a button bar
//            OWLLabeledComponent lc = new OWLLabeledComponent("Destinations", new JScrollPane(list));
//            lc.addHeaderButton(new AbstractAction("Add Destination...",
//                    OWLIcons.getAddIcon(OWLIcons.RDF_INDIVIDUAL)) {
//                public void actionPerformed(ActionEvent e) {
//                    addDestination();
//                }
//
////                public void actionPerformed(ActionEvent e) {
////                    throw new UnsupportedOperationException("Not supported yet.");
////                }
//            });
//
//            // Add everything into the JPanel
//            setLayout(new BorderLayout());
//            add(BorderLayout.CENTER, lc);
//        }
//
//        private void addDestination() {
//            OWLNamedClass newType = OWLUI.pickOWLNamedClass(owlModel,
//                    Collections.singleton(destinationClass), "Select type of new Destination");
//            if (newType != null) {
//                String name = JOptionPane.showInputDialog(
//                        "Enter name of new " + newType.getBrowserText());
//                if (name != null) {
//                    newType.createOWLIndividual(name);
//                }
//            }
//        }
//
//        public void dispose() {
//            owlModel.removeModelListener(modelListener);
//        }
//
//        private void handleDestinationAdded(RDFResource destination) {
//            listModel.addElement(destination);
//            list.setSelectedValue(destination, true);
//        }
//    }
}