/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Search;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Polygon;
import javax.swing.Icon;

/**
 *
 * @author Nikos
 */


public class Icons implements Icon {
  private Color color;

  private boolean selected;

  private int width;

  private int height;

  private Polygon poly;

  private static final int DEFAULT_WIDTH = 10;

  private static final int DEFAULT_HEIGHT = 10;

  public Icons(Color color) {
    this(color, true, DEFAULT_WIDTH, DEFAULT_HEIGHT);
  }

  public Icons(Color color, boolean selected) {
    this(color, selected, DEFAULT_WIDTH, DEFAULT_HEIGHT);
  }

  public Icons(Color color, boolean selected, int width, int height) {
    this.color = color;
    this.selected = selected;
    this.width = width;
    this.height = height;
    initPolygon();
  }


  private void initPolygon() {
    poly = new Polygon();
    int halfWidth = width / 2;
    int halfHeight = height / 2;
    poly.addPoint(0, halfHeight);
    poly.addPoint(halfWidth, 0);
    poly.addPoint(width, halfHeight);
    poly.addPoint(halfWidth, height);
  }

  public int getIconHeight() {
    return height;
  }

  public int getIconWidth() {
    return width;
  }

  public void paintIcon(Component c, Graphics g, int x, int y) {
    g.setColor(color);
    g.translate(x, y);
    if (selected) {
      g.fillPolygon(poly);
    } else {
      g.drawPolygon(poly);
    }
    g.translate(-x, -y);
  }
}




//class DiamondIcon implements Icon {
//
//  private Color color0;
//  private Color color1;
//  private Color color2;
//
//  private boolean selected;
//
//  private int width;
//
//  private int height;
//
//  private int halfWidth;
//
//  private int halfHeight;
//
//  private Polygon poly;
//  private Polygon poly1;
//  private Polygon poly2;
//
//  private static final int DEFAULT_WIDTH = 30;
//
//  private static final int DEFAULT_HEIGHT = 10;
//
//  public DiamondIcon(Color color0, Color color1, Color color2) {
//    this(color0, color1, color2, true, DEFAULT_WIDTH, DEFAULT_HEIGHT);
//  }
//
//  public DiamondIcon(Color color0, Color color1, Color color2, boolean selected) {
//    this(color0, color1, color2, selected, DEFAULT_WIDTH, DEFAULT_HEIGHT);
//  }
//
//  public DiamondIcon(Color color0, Color color1, Color color2, boolean selected, int width, int height) {
//    this.color0 = color0;
//    this.color1 = color1;
//    this.color2 = color2;
//    this.selected = selected;
//    this.width = width;
//    this.height = height;
//    this.halfWidth = width / 2;
//    this.halfHeight = height / 2;
//    initPolygon();
//  }
//
//  private void initPolygon() {
//    poly = new Polygon();
//    poly.addPoint(0, halfHeight);
//    poly.addPoint(halfWidth/3, 0);
//    poly.addPoint(width/3, halfHeight);
//    poly.addPoint(halfWidth/3, height);
//    poly1 = new Polygon();
//    poly1.addPoint(0 + width/3, halfHeight);
//    poly1.addPoint(halfWidth/3 + width/3, 0);
//    poly1.addPoint(width/3 + width/3, halfHeight);
//    poly1.addPoint(halfWidth/3 + width/3, height);
//    poly2 = new Polygon();
//    poly2.addPoint(0 + 2*width/3, halfHeight);
//    poly2.addPoint(halfWidth/3 + 2*width/3, 0);
//    poly2.addPoint(width/3 + 2*width/3, halfHeight);
//    poly2.addPoint(halfWidth/3 + 2*width/3, height);
//  }
//
//  public int getIconHeight() {
//    return height;
//  }
//
//  public int getIconWidth() {
//    return width;
//  }
//
//  public void paintIcon(Component c, Graphics g, int x, int y) {
//    g.setColor(color0);
//    g.translate(x, y);
////    if (selected)
////    {
//      g.fillPolygon(poly);
////    } else {
////      g.drawPolygon(poly);
////    }
//    g.translate(-x, -y);
//
//    g.setColor(color1);
//    g.translate(x, y);
////    if (selected)
////    {
//      g.fillPolygon(poly1);
////    } else {
////      g.drawPolygon(poly);
////    }
//    g.translate(-x, -y);
//
//    g.setColor(color2);
//    g.translate(x, y);
////    if (selected)
////    {
//      g.fillPolygon(poly2);
////    } else {
////      g.drawPolygon(poly);
////    }
//    g.translate(-x, -y);
//  }
