
/* To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Search;

import Index.IndexJDialog;
import Ontology.Ontology;
import edu.stanford.smi.protege.Application;
import edu.stanford.smi.protege.util.ModalDialog;
import edu.stanford.smi.protegex.owl.model.OWLDatatypeProperty;
import edu.stanford.smi.protegex.owl.model.OWLIndividual;
import edu.stanford.smi.protegex.owl.model.OWLModel;
import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
import edu.stanford.smi.protegex.owl.model.RDFResource;
import gontogle.MainFrame;
import java.io.IOException;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map.Entry;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
//import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;

/**
 *
 * @author Nikos
 */
public class Search {

    public static ArrayList<SearchResultObj> results;
    public static OWLModel owlModel;
    public static ArrayList<String> searchInstanceNames = new ArrayList<String>();  //krataei ta insacnces names pu tha ginei to search
    public static Collection searchInstances;    ///krataei ta insacnces pu tha ginei to search
    public static ArrayList<OWLNamedClass> searchClasses = new ArrayList<OWLNamedClass>();
    private static boolean resUpadatedFlag;//used at proximity

    public static void nextGeneration() {
        resUpadatedFlag = false;
        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();
        ArrayList<OWLNamedClass> subClasses = new ArrayList<OWLNamedClass>();


        for (int sCl = 0; sCl < searchClasses.size(); sCl++) {
            ArrayList<OWLIndividual> tmpInst = Ontology.getSubClassesInstances(searchClasses.get(sCl));
            for (int i = 0; i < tmpInst.size(); i++) {
                if (!instances.contains(tmpInst.get(i))) {
                    instances.add(tmpInst.get(i));
                }
            }

            //find subclassesNames for fill GUI
            Collection tmpSubCl = searchClasses.get(sCl).getSubclasses(false);
            Iterator iter = tmpSubCl.iterator();
            while (iter.hasNext()) {
                RDFResource cls = (RDFResource) iter.next();
                if (cls instanceof OWLNamedClass) {


                    if (!subClasses.contains((OWLNamedClass) cls)) {
                        subClasses.add((OWLNamedClass) cls);
                    }
                }
            }
        }
        if (!instances.isEmpty()) {
            resUpadatedFlag = true;
            results = new ArrayList<SearchResultObj>();
            // searchInstances.removeAll(searchInstances); // .clear();
            searchInstances = instances;
            searchClasses.removeAll(searchClasses);
            searchClasses.addAll(subClasses);
        }
    }

    public static void previusGeneration() {
        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();
        ArrayList<OWLNamedClass> superClasses = new ArrayList<OWLNamedClass>();


        for (int sCl = 0; sCl < searchClasses.size(); sCl++) {
            ArrayList<OWLIndividual> tmpInst = Ontology.getSuperClassesInstances(searchClasses.get(sCl));
            for (int i = 0; i < tmpInst.size(); i++) {
                if (!instances.contains(tmpInst.get(i))) {
                    instances.add(tmpInst.get(i));
                }
            }

            //find superclassesNames for fill GUI
            Collection tmpSuperCl = searchClasses.get(sCl).getSuperclasses(false);
            Iterator iter = tmpSuperCl.iterator();
            while (iter.hasNext()) {
                RDFResource cls = (RDFResource) iter.next();
                if (cls instanceof OWLNamedClass) {


                    if (!superClasses.contains((OWLNamedClass) cls)) {
                        superClasses.add((OWLNamedClass) cls);
                    }
                }
            }
        }
        if (!instances.isEmpty()) {
            results = new ArrayList<SearchResultObj>();
            //searchInstances=searchInstances;
            searchInstances = instances;
            searchClasses.removeAll(searchClasses);
            searchClasses.addAll(superClasses);
        }
    }

    public static void proximitySearch(int type) {
        ArrayList<SearchResultObj> firstLevelResults = new ArrayList<SearchResultObj>();    //0,57 factor
        ArrayList<SearchResultObj> secondLevelResults = new ArrayList<SearchResultObj>();   //0,2  factor
        ArrayList<SearchResultObj> thirdLevelResults = new ArrayList<SearchResultObj>();    //0,14 factor

        search(type);           //first Level
        firstLevelResults = results;

        nextGeneration();       //second Level
        search(type);

        if (resUpadatedFlag == true) {
            secondLevelResults = results;
        }

        nextGeneration();         //thrird Level
        search(type);
        if (resUpadatedFlag == true) {
            thirdLevelResults = results;
        }

        for (int i = 0; i < firstLevelResults.size(); i++) {
            firstLevelResults.get(i).setScore((float) (firstLevelResults.get(i).getScore() * 0.57));
        }

        for (int i = 0; i < secondLevelResults.size(); i++) {
            secondLevelResults.get(i).setScore((float) (secondLevelResults.get(i).getScore() * 0.29));
        }

        for (int i = 0; i < thirdLevelResults.size(); i++) {
            thirdLevelResults.get(i).setScore((float) (thirdLevelResults.get(i).getScore() * 0.14));
        }

        ArrayList<SearchResultObj> tmpMergedRes = mergeProximitySearchResults(firstLevelResults, secondLevelResults);
        results = mergeProximitySearchResults(tmpMergedRes, thirdLevelResults);

    }

    public static void similarSearch() {


        int resNum = MainFrame.resultsTable.getSelectedRow();

        SearchResultObj res = results.get(resNum);
        ArrayList<String> classesNames = new ArrayList<String>();
        classesNames = res.getClasses();

        //clean results
        results = new ArrayList<SearchResultObj>();

        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();
        OWLNamedClass cl;


        for (int i = 0; i < classesNames.size(); i++) {
            cl = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+classesNames.get(i));
            if (cl == null) {//check ontology URI with #
                cl = owlModel.getOWLNamedClass(owlModel.getDefaultOWLOntology().getURI()+"#"+classesNames.get(i));
            }
            instances.addAll(cl.getInstances(false));
        }

        searchInstances = instances;
        results = ontologySearch(); //Kaleitai h synarthsh anazhthshs.
        results = sortResults(results);
    //       results = normalizeResultsScores(results);




    }

    public static void relatedSearch() {


        int resNum = MainFrame.resultsTable.getSelectedRow();

        SearchResultObj res = results.get(resNum);
        String docURL = res.getPath();
        //clean results
        results = new ArrayList<SearchResultObj>();
        ArrayList<OWLIndividual> instances = new ArrayList<OWLIndividual>();
        instances = Ontology.getAnnotClassesAllInsancesForDocSearch(owlModel, docURL);


        searchInstances = instances;
        results = ontologySearch(); //Kaleitai h synarthsh anazhthshs.
        results = sortResults(results);
    //      results = normalizeResultsScores(results);

    }

    public static void search(int type) {
        results = new ArrayList<SearchResultObj>();
//            NewJFrame.rendererFlag = 0;

        //*** Anazhthsh mono me lekseis kleidia. ***
        if (type == 1) {

            results = searchKeyword();



        }
//        //*** Anazhthsh mono sthn ontologia. ***
        else if (type == 2) {
            updateSearchInstance();

            if (searchInstances == null || searchInstances.isEmpty()) {
                selectInstacnes();

            }

            results = ontologySearch(); //Kaleitai h synarthsh anazhthshs.
            results = sortResults(results);
        // results = normalizeResultsScores(results);      //fixxxxxxxxxx e?????????????????????????????/
        }

        //        //*** Syndyastikh anazhthsh ***
        else {


            if (!MainFrame.keywordField.getText().equals("")) {


                ArrayList<SearchResultObj> keyWordsResults;
                ArrayList<SearchResultObj> ontoResults;


                keyWordsResults = searchKeyword();
                updateSearchInstance();

                if (searchInstances == null || searchInstances.isEmpty()) {
                    selectInstacnes();
                }

                ontoResults = ontologySearch(); //Kaleitai h synarthsh anazhthshs.

                results = compineResults(keyWordsResults, ontoResults);
                results = sortResults(results);
            //       results = normalizeResultsScores(results);

            }
            else {
                JOptionPane.showMessageDialog(null, "Please enter keywords", "No keywords found", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    public static ArrayList<SearchResultObj> searchKeyword() {
        ArrayList<SearchResultObj> res;
        String field = "contents";
        String queries = null;
        String normsField = null;

        res = new ArrayList<SearchResultObj>();

//            String results="";

        //Diabazw to trexon index tou Lucene
        String index;
        if (MainFrame.selectedIndex == null || MainFrame.selectedIndex.isEmpty() || MainFrame.selectedIndex.compareTo(MainFrame.noIndexCreated) == 0) {
            index = IndexJDialog.validateAndUpdateIndexListFile();
        }
        else {
            index = MainFrame.selectedIndex;
        }
        //    index = memory;

        if (MainFrame.selectedIndex == null || MainFrame.selectedIndex.isEmpty() || MainFrame.selectedIndex.compareTo(MainFrame.noIndexCreated) == 0) {
            JOptionPane.showMessageDialog(null, "No Index has been created! Create an Index .", "Error", JOptionPane.ERROR_MESSAGE);
            return res;
        }

        IndexReader reader = null;
        try {
            reader = IndexReader.open(index);
//        } catch (CorruptIndexException ex) {
//            Logger.getLogger(Search.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Search.class.getName()).log(Level.SEVERE, null, ex);
        }



        Searcher searcher = new IndexSearcher(reader);
        Analyzer analyzer = new StandardAnalyzer();

        if (queries == null) {
//            System.out.print("Query: ");
        }

        String line = "";
        line = MainFrame.keywordField.getText();


        if (!line.equals("")) { //An yparxei query
            QueryParser parser = new QueryParser(field, analyzer);
            parser.setDefaultOperator(QueryParser.AND_OPERATOR);//.setOperator(QueryParser.DEFAULT_OPERATOR_AND); //setDefaultOperator(QueryParser.AND_OPERATOR); // .setOperator(QueryParser.DEFAULT_OPERATOR_AND);
            Query query = null;
            try {
                query = parser.parse(line);
            } catch (ParseException ex) {
                Logger.getLogger(Search.class.getName()).log(Level.SEVERE, null, ex);
            }

//            System.out.println("Searching for: " + query.toString(field));
//            System.out.println(parser.getDefaultOperator().toString());

            Hits hits = null;
            try {
                hits = searcher.search(query);
            } catch (IOException ex) {
                Logger.getLogger(Search.class.getName()).log(Level.SEVERE, null, ex);
            }

//            System.out.println(hits.length() + " total matching documents");

            Document doc;
            String path = "";
            String title = "";
            String title1 = "";

            //hitsData.removeAllElements();

            try {


                for (int i = 0; i < hits.length(); i++) {

                    doc = hits.doc(i);
                    float score = hits.score(i);
                    path = doc.get("path");
                    title1 = path.substring(path.lastIndexOf("\\") + 1);

                    if (path != null) {
                        title = title1;
                        SearchResultObj result;
                        result = new SearchResultObj(false, false, true, null, title, score, path);
                        res.add(result);

                    //  hitsData.add(elements);
                    }
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }

        }
        else {
            JOptionPane.showMessageDialog(null, "Please enter keywords", "No keywords found", JOptionPane.ERROR_MESSAGE);
        }

        return res;
    }

    private void annotateFileButton() {
    }

    private static ArrayList<SearchResultObj> ontologySearch() {
        ArrayList<SearchResultObj> res;
        Object obj;
        res = new ArrayList<SearchResultObj>();

        if ((searchInstances != null) && (!searchInstances.isEmpty())) {
            OWLIndividual individual;
            Collection instances = searchInstances; //Edw apo8hkeuontai ta stigmiotypa twn epilegmenwn pros anazhthsh klasewn.

            LinkedHashMap<String, SearchResultObj> tmpResults = new LinkedHashMap<String, SearchResultObj>();//ta result ana doc
            OWLDatatypeProperty URLProp = owlModel.getOWLDatatypeProperty(Ontology.URLPropName);
            OWLDatatypeProperty percProp = owlModel.getOWLDatatypeProperty(Ontology.percPropName);

//loop for all instances
            for (Iterator jt = instances.iterator(); jt.hasNext();) {

                obj = jt.next();
                if (obj instanceof OWLIndividual) {
                    individual = (OWLIndividual) obj;
//                    System.out.println(individual.getName());
////edo ixe provlima nik
                    if (individual.getPropertyValue(URLProp) == null || individual.getPropertyValue(percProp) == null) {//not gontogle's instance
                        continue;
                    }

                    String url = (String) individual.getPropertyValue(URLProp);
                    String fileName = url.substring(url.lastIndexOf("\\") + 1);
                    float perc = (Float) individual.getPropertyValue(percProp);
                    Collection types = individual.getRDFTypes();
                    Iterator iterator = types.iterator();
                    ArrayList<String> classes = new ArrayList<String>();

                    while (iterator.hasNext()) {
                        RDFResource cl = (RDFResource) iterator.next();
                        if (cl instanceof OWLNamedClass) {
                            if (searchClasses.contains(cl)) {
                                classes.add(cl.getLocalName());
                            }
                        }
                    } // while

                    boolean whole = false;
                    boolean part = false;
                    boolean keyword = false;
                    if (tmpResults.containsKey(url)) {
                        SearchResultObj oldResObj = tmpResults.get(url);
                        ArrayList<String> oldClasses = oldResObj.getClasses();
                        part = oldResObj.isPartOfDoc();
                        whole = oldResObj.isWholeDoc();
                        float oldSCore = oldResObj.getScore();


                        if (perc == ((float) 100)) {
                            whole = true;
                        }
                        else {
                            part = true;
                        }
                        int j;
                        for (int i = 0; i < oldClasses.size(); i++) {
                            String cl = oldClasses.get(i);
                            for (j = 0; j < classes.size(); j++) {
                                if (classes.get(j).compareToIgnoreCase(cl) == 0) {
                                    break;
                                }
                            }
                            if (j == classes.size()) {
                                classes.add(cl);
                            }
                        }

                        perc = perc / searchClasses.size();  //to pososto dia ton arithmo twn klasewn

                        float newPerc = perc + oldSCore;
                        float maxPerc = 100;
                        if (newPerc > maxPerc) { //noramalize
                            newPerc = maxPerc;
                        }
                        // newPerc=newPerc/searchClasses.size();  //to pososto dia ton arithmo twn klasewn

                        tmpResults.remove(url);
                        SearchResultObj resObj = new SearchResultObj(whole, part, keyword, classes, fileName, newPerc, url);
                        tmpResults.put(url, resObj);

                    }
                    else {
                        if (perc == ((float) 100)) {
                            whole = true;
                        }
                        else {
                            part = true;
                        }
                        perc = perc / searchClasses.size();  //to pososto dia ton arithmo twn klasewn

                        SearchResultObj resObj = new SearchResultObj(whole, part, keyword, classes, fileName, perc, url);
                        tmpResults.put(url, resObj);
                    }





                //return res;

                }
            }

            for (Entry<String, SearchResultObj> entry : tmpResults.entrySet()) {
                res.add(entry.getValue());
            }
        }

        return res;
    }

    private static void updateSearchInstance() { //check gui if user delete an instace
//        OWLIndividual individual;
//        int i;
//        ArrayList<OWLIndividual> newSearchInstance = new ArrayList<OWLIndividual>();
//        String guiInput = MainFrame.conceptField.getText();
//        String[] guiInstances = guiInput.split(",");
//        if (searchInstances != null) {
//            for (Iterator jt = searchInstances.iterator(); jt.hasNext();) {
//
//                individual = (OWLIndividual) jt.next();
//                String indName = individual.getName();
//
//                for (i = 0; i < guiInstances.length; i++) {
//                    if (guiInstances[i].trim().compareToIgnoreCase(indName) == 0) {
//                        break;
//                    }
//                }
//                if (i != guiInstances.length) {
//                    newSearchInstance.add(individual);
//
//                //searchInstances.remove((OWLIndividual)individual);
//                }
//
//            }
//            searchInstances = newSearchInstance;
//            searchInstanceNames = new ArrayList<String>();
//            for (Iterator jt = searchInstances.iterator(); jt.hasNext();) {
//                individual = (OWLIndividual) jt.next();
//
//                searchInstanceNames.add(individual.getName());
//            }
//        }
    }

    public static void selectInstacnes() {
        OWLIndividual individual;
        searchInstanceNames = new ArrayList<String>();

        Collection tmp = pickRDFResources(Collections.singleton(owlModel.getOWLThingClass()));
        if (tmp.isEmpty()) {

            return;
        }
        else {
            searchClasses = SelectInstancesPanel1.tmpClasses;
            searchInstances = tmp;
        }
        for (Iterator jt = searchInstances.iterator(); jt.hasNext();) {
            individual = (OWLIndividual) jt.next();

            searchInstanceNames.add(individual.getName());
        }
    }

    public static String getClassesNames() {
        String classes = "";
        //jTable1.setValueAt(aViewer, WIDTH, WIDTH);
        for (int i = 0; i < searchClasses.size(); i++) {

            classes += searchClasses.get(i).getLocalName();
            if (i != searchClasses.size() - 1) {
                classes += " , ";
            }
        }

        return classes;
    }

    /**
     * Emfanizei ena plaisio me thn ierarxia ths ontologias kai ta
     * stigmiotypa ths ekastote epilegmenhs klashs.
     * @param allowedClasses
     * @return
     */
    public static Collection pickRDFResources(Collection allowedClasses) {
        //  OWLModel tempOwlModel = getOWLModel(allowedClasses);
        OWLSelectInstancesPanel1 panel = new OWLSelectInstancesPanel1(owlModel, allowedClasses);
        int result = ModalDialog.showDialog(Application.getMainWindow(), panel, "Select Instance", ModalDialog.MODE_OK_CANCEL);
        if (result == ModalDialog.OPTION_OK) {
            Collection instances = panel.getSelection();

//            System.out.println("&&&&*******" + instances);
            return instances;
        }
        else {

            return Collections.EMPTY_LIST;
        }
    }

    private static ArrayList<SearchResultObj> mergeProximitySearchResults(ArrayList<SearchResultObj> res1, ArrayList<SearchResultObj> res2) {
        int j, i;
        String keyPath;

        ArrayList<SearchResultObj> comRes = new ArrayList<SearchResultObj>();

        for (i = 0; i < res1.size(); i++) {
            keyPath = res1.get(i).getPath();
            SearchResultObj tmp1 = res1.get(i);
            for (j = 0; j < res2.size(); j++) {
                if (res2.get(j).getPath().compareToIgnoreCase(keyPath) == 0) {
                    SearchResultObj tmp2;

                    tmp2 = res2.get(j);
                    tmp2.setKeywordsFound(tmp2.isKeywordsFound() || tmp1.isKeywordsFound());
                    tmp2.setPartOfDoc(tmp2.isPartOfDoc() || tmp1.isPartOfDoc());
                    tmp2.setWholeDoc(tmp2.isWholeDoc() || tmp1.isWholeDoc());
                    tmp2.setScore(tmp2.getScore() + res1.get(i).getScore()); ///eeeeeeeeeeeeee to athrisma twn scoar!!!!!!!!!!!!!!!
                    ArrayList<String> consTmp = tmp2.getClasses();
                    if (consTmp != null && res1.get(i).getClasses() != null) {
                        consTmp.addAll(res1.get(i).getClasses());
                        tmp2.setClasses(consTmp);
                    }
                    comRes.add(tmp2);
                    break;
                }
            }
            if (j == res2.size()) {
                comRes.add(tmp1);
            }
        }

        for (j = 0; j < res2.size(); j++) {
            keyPath = res2.get(j).getPath();
            for (i = 0; i < comRes.size(); i++) {
                if (comRes.get(i).getPath().compareToIgnoreCase(keyPath) == 0) {
                    break;
                }
            }
            if (i == comRes.size()) {
                comRes.add(res2.get(j));
            }
        }

        return comRes;



    }

    private static ArrayList<SearchResultObj> compineResults(ArrayList<SearchResultObj> keyRes, ArrayList<SearchResultObj> ontoRes) {
        ArrayList<SearchResultObj> comRes = new ArrayList<SearchResultObj>();
        String keyPath;
        int j, i;
        float half = (float) 0.5;
        if (((String) MainFrame.andorComboBox.getSelectedItem()).equals("AND")) {

            for (i = 0; i < keyRes.size(); i++) {
                keyPath = keyRes.get(i).getPath();
                for (j = 0; j < ontoRes.size(); j++) {
                    if (ontoRes.get(j).getPath().compareToIgnoreCase(keyPath) == 0) {
                        SearchResultObj tmp;
                        tmp = ontoRes.get(j);
                        tmp.setKeywordsFound(true);
                        tmp.setScore(tmp.getScore() * half + keyRes.get(i).getScore() * half); ///eeeeeeeeeeeeee to athrisma twn score!!!!!!!!!!!!!!!

//                        ArrayList<String> OntoClasses = tmp.getClasses();
//                        ArrayList<String> compineClasses = new ArrayList<String>();
//                        ArrayList<String> keyClasses = keyRes.get(i).getClasses();
                        //join classes 
//                        for (int c1 = 0; c1 < OntoClasses.size(); c1++) {
//                            String oCl = OntoClasses.get(c1);
//                            for (int c2 = 0; c2 < keyClasses.size(); c2++) {
//                                if (keyClasses.get(c2).compareToIgnoreCase(oCl) == 0) {
//                                    compineClasses.add(oCl);
//                                    break;
//                                }
//                            }
//                        }

                        //tmp.setClasses(OntoClasses);
                        comRes.add(tmp);
                        break;
                    }
                }
            }
        }
        else {  //OR
            for (i = 0; i < keyRes.size(); i++) {
                keyPath = keyRes.get(i).getPath();
                for (j = 0; j < ontoRes.size(); j++) {
                    if (ontoRes.get(j).getPath().compareToIgnoreCase(keyPath) == 0) {
                        SearchResultObj tmp;
                        tmp = ontoRes.get(j);
                        tmp.setKeywordsFound(true);
                        tmp.setScore(tmp.getScore() * half + keyRes.get(i).getScore() * half); ///eeeeeeeeeeeeee to athrisma twn score!!!!!!!!!!!!!!!

                        //     ArrayList<String> OntoClasses = tmp.getClasses();
//                        ArrayList<String> compineClasses = new ArrayList<String>();
//                        ArrayList<String> keyClasses = keyRes.get(i).getClasses();
//                        //join classes
//                        for (int c1 = 0; c1 < OntoClasses.size(); c1++) {
//                            String oCl = OntoClasses.get(c1);
//                            for (int c2 = 0; c2 < keyClasses.size(); c2++) {
//                                if (keyClasses.get(c2).compareToIgnoreCase(oCl) == 0) {
//                                    compineClasses.add(oCl);
//                                    break;
//                                }
//                            }
//                        }
                        //tmp.setClasses(OntoClasses);
                        comRes.add(tmp);
                        break;
                    }
                }
                if (j == ontoRes.size()) {
                    SearchResultObj tmp2;
                    tmp2 = keyRes.get(i);
                    tmp2.setScore(tmp2.getScore() * half);
                    comRes.add(tmp2);
                }
            }

            for (j = 0; j < ontoRes.size(); j++) {
                keyPath = ontoRes.get(j).getPath();
                for (i = 0; i < comRes.size(); i++) {
                    if (comRes.get(i).getPath().compareToIgnoreCase(keyPath) == 0) {
                        break;
                    }
                }
                if (i == comRes.size()) {
                    SearchResultObj tmp2;
                    tmp2 = ontoRes.get(j);
                    tmp2.setScore(tmp2.getScore() * half);
                    comRes.add(tmp2);
                }
            }



        }
        return comRes;
    }

    private static ArrayList<SearchResultObj> sortResults(ArrayList<SearchResultObj> res) {
        ArrayList<SearchResultObj> sortRes = new ArrayList<SearchResultObj>();
        ArrayList<Float> scores = new ArrayList<Float>();

        for (int i = 0; i < res.size(); i++) {
            scores.add(res.get(i).getScore());
        }
        Collections.sort(scores);

        for (int i = scores.size() - 1; i >= 0; i--) {

            for (int j = 0; j < res.size(); j++) {
                if (res.get(j).getScore() == scores.get(i)) {
                    sortRes.add(res.get(j));
                    res.remove(j);
                    break;
                }
            }

        }
        return sortRes;
    }

    private static ArrayList<SearchResultObj> normalizeResultsScores(ArrayList<SearchResultObj> res) {
        ArrayList<SearchResultObj> normRes = new ArrayList<SearchResultObj>();
        // ArrayList<Float> scores =new ArrayList<Float>();
        float scoreSum = 0;
        float normFactor;

        for (int i = 0; i < res.size(); i++) {
            scoreSum += res.get(i).getScore();
        }

        normFactor = ((float) 100) / scoreSum;

        for (int i = 0; i < res.size(); i++) {
            normRes.add(res.get(i));
            normRes.get(i).setScore(normRes.get(i).getScore() * normFactor);
        //   res.get(i).setScore(res.get(i).getScore()*normFactor);
        }
        return normRes;
    }

//    private static OWLModel getOWLModel(Collection allowedClses) {
//        Cls cls = (Cls) CollectionUtilities.getFirstItem(allowedClses);
//        if (cls instanceof RDFSClass) {
//            return ((RDFSClass) cls).getOWLModel();
//        }
//        else {
//            // we have to hack it
//            return (OWLModel) ProjectManager.getProjectManager().getCurrentProject().getKnowledgeBase();
//        }
//    }
}