/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gontogle;

import AutoAnnotation.AutomaticAnnotator;
import Index.IndexJDialog;
import OpenOffice.OOfficeDoc;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Nikos
 */
public class initConfiguration {

    public static final String configFile = "conf.ini";
    public static final String ooPathVarName = "openOfficePath";
    public static final String ooPathDefaultValue = "C:/Program Files/OpenOffice.org 3";
    public static String ooPathValue;
    public static final String kFactorVarName = "K";
    public static final int kFactorDefaultValue = 5;
    public static int kFactorValue;
    public static final String selectedIndexVarName = "selectedIndex";
    public static final String selectedIndexDefaultValue = "";
    public static String selectedIndexValue;
    public static String IPVarName = "IP";
    public static String IPDefaultValue = "147.102.12.175";
    public static String IPVarValue;
    public static String userVarName = "User";
    public static String userDefaultValue = "Guest";
    public static String userVarValue;
    public static String passVarName = "Passoword";
    public static String passDefaultValue = "guest";
    public static String passVarValue;

    public static void init() throws IOException {
        File f;
        f = new File(configFile);
        if (!f.exists()) {
            try {
                f.createNewFile();
                FileWriter fstream = new FileWriter(configFile, false);
                BufferedWriter out = new BufferedWriter(fstream);

                out.write(ooPathVarName + "=" + ooPathDefaultValue);
                out.newLine();
                out.write(kFactorVarName + "=" + kFactorDefaultValue);
                out.newLine();
                out.write(selectedIndexVarName + "=" + selectedIndexDefaultValue);
                //server
                out.newLine();
                out.write(IPVarName + "=" + IPDefaultValue);
                out.newLine();
                out.write(userVarName + "=" + userDefaultValue);
                out.newLine();
                out.write(passVarName + "=" + passDefaultValue);

                out.close();

                kFactorValue = kFactorDefaultValue;
                ooPathValue = ooPathDefaultValue;
                selectedIndexValue = selectedIndexDefaultValue;
                IPVarValue = IPDefaultValue;
                userVarValue = userDefaultValue;
                passVarValue = passDefaultValue;
            } catch (IOException ex) {
                Logger.getLogger(IndexJDialog.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {//exist ..read it

            FileInputStream fstream = new FileInputStream(configFile);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String line;
            while ((line = br.readLine()) != null) {
                if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(ooPathVarName) == 0) { //oopath
                    ooPathValue = line.substring(line.indexOf("=") + 1, line.length());
                } else if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(kFactorVarName) == 0) { //k factor
                    kFactorValue = (int) Integer.parseInt(line.substring(line.indexOf("=") + 1, line.length()));
                } else if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(selectedIndexVarName) == 0) { //
                    selectedIndexValue = line.substring(line.indexOf("=") + 1, line.length());
                } else if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(IPVarName) == 0) { //
                    IPVarValue = line.substring(line.indexOf("=") + 1, line.length());
                } else if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(userVarName) == 0) { //
                    userVarValue = line.substring(line.indexOf("=") + 1, line.length());
                } else if (line.substring(0, line.indexOf("=")).compareToIgnoreCase(passVarName) == 0) { //
                    passVarValue = line.substring(line.indexOf("=") + 1, line.length());
                }

            }
        }

        initJavaVariables();
    }

    public static void modifyConfig(int newK, String newOOPath, String selIndex, String IP, String user, String pass) {
        try {
            File f;
            f = new File(configFile);
            f.createNewFile();
            FileWriter fstream = new FileWriter(configFile, false);
            BufferedWriter out = new BufferedWriter(fstream);
            out.write(ooPathVarName + "=" + newOOPath);
            out.newLine();
            out.write(kFactorVarName + "=" + newK);
            out.newLine();
            out.write(selectedIndexVarName + "=" + selIndex);
            out.newLine();

            out.write(IPVarName + "=" + IP);
            out.newLine();
            out.write(userVarName + "=" + user);
            out.newLine();
            out.write(passVarName + "=" + pass);
            out.close();

            kFactorValue = newK;
            ooPathValue = newOOPath;
            selectedIndexValue = selIndex;

            IPVarValue = IP;
            userVarValue = user;
            passVarValue = pass;

            initJavaVariables();
        } catch (IOException ex) {
            Logger.getLogger(initConfiguration.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private static void initJavaVariables() {
        AutomaticAnnotator.K = kFactorValue;
        OOfficeDoc.ooPath = ooPathValue;
        MainFrame.selectedIndex = selectedIndexValue;
        MainFrame.serverIP = IPVarValue;
        MainFrame.serverPass = passVarValue;
        MainFrame.serverUser = userVarValue;


    }
}
